#include <fstream>
#include <iostream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

const int N = 1e5 + 4;

int len[N], dp[N], m[N], pos[N];
vector <pair <int, int> > v[20];


inline int last(const pair <int, int> &A) {
    return (A.second) / m[A.second];
}

bool cmp (const pair <int, int> &A, const pair <int, int> &B) {
    if (A.first > B.first)
        return true;
    if (A.first < B.first)
        return false;
    if (m[A.second] < m[B.second])
        return true;
    if (m[A.second] > m[B.second])
        return false;

    return pos[last(A)] < pos[last(B)];
}

int main() {
    int a, b, x, maxim, start1, lim = 0, type;
    ifstream cin ("multisum.in");
    ofstream cout ("multisum.out");

    b = 1e5;
    len[1] = 1;
    dp[1] = 1;
    m[1] = 1;
    for (int i = 1; i<= b; i++) {
        for (int j = 2 * i; j <= b; j = j + i) {
            if (len[j + 1] < 1 + len[i]) {
                len[j + 1] = 1 + len[i];
                dp[j + 1] = dp[i];
                m[j + 1] = j / i;
            }
            else
                if (len[j + 1] == 1 + len[i]) {
                    dp[j + 1] = dp[j + 1] + dp[i];
                    m[j + 1] = min(m[j + 1], j / i);
                }
        }
    }

    for (int i = b; i >= 1; i--) {
        for (int j = 2 * i; j <= b; j = j + i)
             if (len[j] < len[i]) {
                len[j] = len[i];
                dp[j] = dp[i];
                m[j] = j / i;
            }
    }

    for (int i = 1; i <= b; i++) {
        if (i % m[i])
            start1 = 1;
        else start1 = 0;
        v[len[i]].push_back(make_pair(start1, i));
        lim = max(lim, len[i]);
    }

    v[1].push_back(make_pair(1, 1));
    v[1].push_back(make_pair(0, 2));

    pos[1] = 0;
    pos[2] = 1;

    for (int i = 2; i <= lim; i++) {
        sort(v[i].begin(), v[i].end(), cmp);
        for (int j = 0; j < v[i].size(); j++)
            pos[v[i][j].second] = j;
    }

    int T;
    long long s = 0;
    cin >> T >> type;

    assert(T>= 1 && T <= 1000);

    for (int t = 0; t < T; t++) {
        cin >> a >> b;

        assert(3 <= a && a <= b && b <= 100000);
        s = s + b - a + 1;
        assert(s <= 100000);

        int maxim = 0, cnt = 0, ans, minim = 0;
        for (int i = a; i <= b; i++) {
            if (maxim < len[i]) {
                maxim = len[i];
                cnt = 1;
                ans = i;
                minim = pos[i];
            }
            else
                if (maxim == len[i]) {
                    ++cnt;
                    if (pos[i] < minim) {
                        minim = pos[i];
                        ans = i;
                    }
                }
        }
        if (type == 1)
            cout << maxim << "\n";
        else
            if (type == 2)
                cout << cnt << "\n";
            else
                cout << ans << "\n";
    }
    assert(s <= 100000);
    return 0;
}

