/*Patrick Catalin Alexandru Sava
Atooom Industry and Resources SRL
University of Bucharest
Expected : 100 points
*/

#include <fstream>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std ;

ifstream cin ("multisum.in") ;
ofstream cout ("multisum.out") ;

vector <int> Ciur (int N) {
	vector <int> prim (N + 1, 1) ;
	vector <int> primes ;
	for (int i = 2 ; i <= N ; ++ i) {
		if (prim [i] == 1) {
			for (int j = 2 * i ; j <= N ; j += i) {
				prim [j] = 0 ;
			}
			primes.push_back (i) ;
		}
	}
	return primes ;
}

vector <int> Sol (int N, vector <int> &primes, vector <int> *&gr8) {
	if (gr8 [N].size()) {
		return gr8 [N] ; 
	}
	if (N == 1) {
		gr8 [N] = vector <int> ({1}) ;
	}
	if (N == 2) {
		gr8 [N] = vector <int> ({2}) ;
	}
	if (N == 3) {
		gr8 [N] = vector <int> ({1, 2}) ;
	}
	if (gr8 [N].size()) {
		return gr8 [N] ; 
	}
	vector <int> best ;
	for (auto x : primes) {
		if (x * x > N) {
			break ; 
		}
		if (N % x) {
			continue ;
		}
		// cout << "********&&&666" << x << '\n' ;
		// cout << N / x << '\n' ; 
		vector <int> temp = Sol (N / x, primes, gr8) ;
		// cout << N / x << " ttttttttttttttttttttt\n" ;
		/*for (auto x : temp) {
			cout << x << ' ' ; 
		}*/
		// cout << "\nttttttttttttttt\n" ;
		if (best.size() < temp.size()) {
			best.clear() ;
			for (auto y : temp) {
				// cout << y << "*& " ; 
				best.push_back (y * x) ; 
			} 
			// cout << '\n' ;
		}
		else if (best.size() == temp.size()) {
			for (int i = 0 ; i < (int)best.size() ; ++ i){
				if (best [i] > x * temp [i]) {
					best.clear() ;
					for (auto y : temp) {
						best.push_back (y * x) ; 
					}
					break ; 
				}
				else if (best [i] < x * temp [i]) {
					break ; 
				}
			}
		}
	}
	N -- ;
	if (best.size() <= 2) {
		best = vector <int> ({1, N}) ;
		// cout << "a intrat\n" ;
	}
	for (auto x : primes) {
		if (x * x > N) {
			break ; 
		}
		if (N % x) {
			continue ;
		}
		// cout << "********&&&777" << x << '\n' ;
		// cout << N / x << '\n' ; 
		vector <int> temp = Sol (N / x, primes, gr8) ;
		reverse (temp.begin(), temp.end());
		for (auto &y : temp) {
			y *= x ; 
		}
		temp.push_back (1) ;
		reverse (temp.begin(), temp.end());
		if (best.size() < temp.size()) {
			best = temp ;
		}
		else if (best.size() == temp.size()) {
			for (int i = 0 ; i < (int)best.size() ; ++ i){
				if (best [i] > temp [i]) {
					best = temp ; 
					break ; 
				}
				else if (best [i] < temp [i]) {
					break ; 
				}
			}
		}
	}
	gr8 [N + 1] = best ; 
	return best ;
}

void Solve123 (vector <pair<int, int>> &Intervals, int type) {
	vector <int> primes = Ciur (1e5) ;
	/*for (auto x : primes) {
		cout << x << '\n' ;
	}
	return ;*/
	vector <int> *gr8 = new vector <int> [100001] ;
	/*for (int i = 1 ; i <= 100 ; ++ i ){
		cout << i << " : " ;
		for (auto z : Sol(i, primes, gr8)) {
			cout << z << ' ' ;
		}
		cout << '\n' ;
		cout << "\n=============================================\n" ;
	}
	return ; */
	for (auto x : Intervals) {
		int best = 0 ; 
		int cate = 0 ;
		for (int i = x.first ; i <= x.second ; ++ i) {
			if (Sol (i, primes, gr8).size() > best) {
				best = Sol (i, primes, gr8).size() ;
				cate = 1 ; 
			}
			else if (Sol (i, primes, gr8).size() == best) {
				cate += 1 ;
			}
			/*for (auto z : gr8 [i]) {
				cout << z << ' ' ;
			}*/
			// cout << "=============================================\n" ;
		}	
		if (type == 1){
			cout << best << '\n' ;
		}
		else {
			if (type == 2){
				cout << cate << '\n' ;
			}
			else {
				vector <int> lexc (1, 1e9) ;
				for (int i = x.first ; i <= x.second ; ++ i) {
					if (gr8[i].size() == best) {
						if (lexc.size() < gr8 [i].size()) {
							lexc = gr8 [i] ; 
							// cout << lexc.size() << ' ' << gr8 [i].size() << '\n' ;
						} 
						else {
							for (int j = 0 ; j < (int)lexc.size() ; ++ j) {
								// cout << lexc [j] << " este comparat cu " << gr8 [i][j] << " iar " << (lexc [j] < gr8 [i][j]) << '\n' ;
								if (lexc [j] > gr8 [i][j]) {
									/*cout << "\n^^^^\n" ;
									for (auto y : lexc) {
										cout << y << ' ' ; 
									}
									cout << "\n^^^^\n" ;
									cout << lexc [j] << " este comparat cu " << gr8 [i][j] << '\n' ;*/
									lexc = gr8 [i] ; 
									break ; 
								}
								else if (lexc [j] < gr8 [i][j]) {
									/*cout << "\n^^^^\n" ;
									for (auto y : lexc) {
										cout << y << ' ' ; 
									}
									cout << "\n^^^^\n" ;*/
									break ;
								}
							}
						}
						/*for (auto y : gr8 [i]) {
							cout << y << ' ' ; 
						}
						cout << '\n' ;*/
					}
				}
				int s = 0 ; 
				for (auto y : lexc) {
					// cout << y << ' ' ; 
					s += y ; 
				}	
				// cout << endl ; 
				cout << s << '\n' ;
			}
		}
	}
}

int main(int argc, char const *argv[])
{
	int n , c ;
	assert(cin >> n >> c) ;
	assert (0 < n and n <= 1000) ;
	assert (c == 1 or c == 2 or c == 3) ;
	vector <pair<int, int>> Intervals ;
	int verif = 0 ; 
	for (int i = 1 ; i <= n ; ++ i) {
		int x, y ; 
		assert(cin >> x >> y) ; 
		verif += y - x + 1 ;
		assert (x <= y) ; 
		assert (2 < x and x <= 100000) ;
		assert (2 < y and y <= 100000) ;
		Intervals.push_back ({x, y}) ;
	}
	assert (verif >= 1 and verif <= 100000) ;
	Solve123 (Intervals, c) ;
	return 0;
}