#include <fstream>

using namespace std;

int dp[2][5003];
const int MOD = 666013;

ifstream cin ("100m.in");
ofstream cout ("100m.out");

int main() {
    int n, l1, l2;

    cin >> n;
    dp[1][1] = 1;
    for (int i = 2; i <= n; i++) {
        l1 = i % 2;
        l2 = (i - 1) % 2;
        dp[l1][1] = 1;
        for (int j = 2; j <= i; j++) {
            dp[l1][j] = dp[l2][j - 1] + dp[l2][j];
            if (dp[l1][j] >= MOD)
                dp[l1][j] -= MOD;
            dp[l1][j] = 1ll * dp[l1][j] * j % MOD;
        }
    }
    int ans = 0;
    l1 = n % 2;
    for (int i = 1; i <= n; i++) {
        ans = ans + dp[l1][i];
        if (ans >= MOD)
            ans -= MOD;
    }
    cout << ans << "\n";
}
