/*Patrick Catalin Alexandru Sava
Atooom Industry and Resources SRL
University of Bucharest 
Expected : 40 points */

#include <fstream>
#include <vector>

using namespace std ;

ifstream cin ("100m.in") ;
ofstream cout ("100m.out") ;

const int MOD = 666013 ;

int main(int argc, char const *argv[])
{
	int n ;
	cin >> n ; 
	vector <int> *dp = new vector <int> [n + 2] ; 
	for (int i = 0 ; i <= n + 1 ; ++ i) {
		dp [i].resize(n + 2) ; 
	}
	dp [0][0] = 1 ;
	for (int i = 1 ; i <= n ; ++ i) {
		for (int j = 1 ; j <= i ; ++ j) {
			dp [i][j] = 1LL * dp [i - 1][j - 1] * j % MOD + 1LL * dp [i - 1][j] * j % MOD ; 
			dp [i][j] %= MOD ;
		}
	}
	int s = 0 ; 
	for (int i = 1 ; i <= n ; ++ i) {
		s += dp [n][i] ;
		s %= MOD ;
	}
	cout << s << '\n' ;
	return 0;
}