/*Patrick Catalin Alexandru Sava
Atooom Industry and Resources SRL
University of Bucharest
Expected : 30*/

#include <fstream>
#include <vector>

using namespace std ;

ifstream cin ("camp.in") ;
ofstream cout ("camp.out") ;

int sgn (pair <int, int> a, pair <int, int> b, pair <int, int> c) 
{
	int res = a.first * b.second + b.first * c.second + c.first * a.second - b.second * c.first - c.second * a.first - a.second * b.first ;
	if (res == 0) 
		return 0 ;
	if (res > 0) 
		return 1 ;
	if (res < 0) 
		return -1 ;
}

bool verif (pair<int, int> point, vector <pair<int, int>> &points, int n) 
{
	int maxim = -5 ; 
	int minim = 5 ; 
	for (int i = 0 ; i < n ; ++ i) {
		maxim = max (maxim , sgn (point, points[i], points[i + 1])) ;
		minim = min (minim , sgn (point, points[i], points[i + 1])) ;
		if (maxim - minim == 2) return 0 ; 
	}
	return 1 ;
}

int main(int argc, char const *argv[])
{
	vector <pair<int, int>> points ; 
	int n ; 
	cin >> n ; 
	int min_x = 1e6 ; 
	int min_y = 1e6 ; 
	int max_x = 0 ; 
	int max_y = 0 ;
	for (int i = 1 ; i <= n ; ++ i) {
		int x, y ; 
		cin >> x >> y ; 
		points.push_back ({x, y}) ;
		min_x = min (min_x, x) ;
		min_y = min (min_y, y) ;
		max_x = max (max_x, x) ;
		max_y = max (max_y, y) ;
	}
	points.push_back (points[0]) ;
	long long sol = 0 ;
	for (int i = min_x ; i <= max_x; ++ i) {
		int a, b ; 
		for (int j = min_y; j <= max_y; ++ j) {
			if (verif ({i, j}, points, n)) {
				a = j ; 
				break ;
			}
		}
		for (int j = max_y; j >= min_y; -- j) {
			if (verif ({i, j}, points, n)) {
				b = j ; 
				break ;
			}
		}
		if (a > b) 
			swap (a, b) ;
		// cout << a << ' ' << b << '\n' ;
		sol += 1LL * (b - a + 1) * i ;
		sol += 1LL * (b + 1) * b / 2LL ;
		sol -= 1LL * (a - 1) * a / 2LL ;
	}
	cout << sol << '\n' ;
	return 0;
}
