/*Patrick Catalin Alexandru Sava
Atooom Industry and Resources SRL
University of Bucharest 
Expected : 100 points */

#include <fstream>
#include <vector>

using namespace std ;

ifstream cin ("100m.in") ;
ofstream cout ("100m.out") ;

const int MOD = 666013 ;

int main(int argc, char const *argv[])
{
	int n ;
	cin >> n ; 
	vector <int> *dp = new vector <int> [2] ; 
	for (int i = 0 ; i <= 1 ; ++ i) {
		dp [i].resize(n + 2) ; 
	}
	int lin = 1 ; 
	dp [0][0] = 1 ;
	for (int i = 1 ; i <= n ; ++ i) {
		for (auto &x : dp[lin]) {
			x = 0 ;
		}
		for (int j = 1 ; j <= i ; ++ j) {
			dp [lin][j] = 1LL * dp [1 - lin][j - 1] * j % MOD + 1LL * dp [1 - lin][j] * j % MOD ; 
			dp [lin][j] %= MOD ;
			// cout << dp [lin][j] << ' ' ; 
		}
		lin = 1 - lin ; 
		// cout << '\n' ;
	}
	int s = 0 ; 
	for (int i = 1 ; i <= n ; ++ i) {
		s += dp [1 - lin][i] ;
		s %= MOD ;
	}
	cout << s << '\n' ;
	return 0;
}